
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Garbage First / iVAN</title>

    <meta name="description" content="Garbage First 1 G1 的基本概念 1 : HotSpot:现有的垃圾回收器: Serial GC, Parallel GC ,Concurrent Mark Sweep Gc 这三个GC不同: 1:如果你想要最小化的使用内存和并行开销:选Serial GC2:如果你想要最大化应用程序的吞吐量选用Parallel GC 3:如果想要最小化GC的中断或停顿时间选CMS GC 2 G1是Garbage First, 意思: G1是一个并行回收器,它把内存分割为很多不相关的区间(Region),每一个区间可以属于老">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Garbage First</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1 G1 的基本概念</h3>
<p><em>1</em>    : <code>HotSpo</code>t:现有的垃圾回收器: <code>Serial GC</code>, <code>Parallel GC</code> ,<code>Concurrent Mark Sweep Gc</code><br />
这三个GC不同:</p>
<blockquote><p>1:如果你想要最小化的使用内存和并行开销:选Serial GC<br /><strong>2</strong>:如果你想要最大化应用程序的吞吐量选用Parallel GC<br />
3:如果想要最小化GC的中断或停顿时间选CMS GC</p></blockquote>
<p><em>2</em>   <code>G1</code>是Garbage First, 意思: G1是一个并行回收器,它把内存分割为很多不相关的区间(<code>Region</code>),每一个区间可以属于老年代或年轻代,并且每个区间上是可以物理上不连续的,老年代区间这个设计理念本身是为了服务于并行后台线程,这些线程的主要工作是寻找未被引用的对象,而这样就会产生一种现象,即某些区间的垃圾多余其它区间,(<code>垃圾回收时都是需要停下应用程序,不然没办法防止应用程序的干扰</code>),然后<code>G1</code>可以集中精力在垃圾最多的区间上,并且只需要一点点时间就可以清空这些区间垃圾,腾出完全空闲的时间.总而言之:<code>G1侧重点在于处理垃圾最多的区间,所以叫Garbege First</code></p>
<p><em>3</em> : G1内部主要有四个操作阶段:</p>
<blockquote><p>1:年轻代回收 (A young Collection)<br />
2: 运行在后台的并行循环(A background Concurrent Cycle)<br />
3: 混合回收(A mixed Collection)<br />
4: 全量回收 (A full GC)</p></blockquote>
<h3>2 进程和线程</h3>
<p>1: 子进程和父进程有<code>不同的代码和数据空间</code>,而<code>多个线程共享数据空间</code>,每个线程都有自己的<code>执行堆栈和程序计数器</code>为其执行上下文</p>
<h3>3 ava###1 G1 的基本概念</h3>
<p><em>1</em>    : <code>HotSpo</code>t:现有的垃圾回收器: <code>Serial GC</code>, <code>Parallel GC</code> ,<code>Concurrent Mark Sweep Gc</code><br />
这三个GC不同:</p>
<blockquote><p>1:如果你想要最小化的使用内存和并行开销:选Serial GC<br /><strong>2</strong>:如果你想要最大化应用程序的吞吐量选用Parallel GC<br />
3:如果想要最小化GC的中断或停顿时间选CMS GC</p></blockquote>
<p>*2   <code>G1</code>是Garbage First, 意思: G1是一个并行回收器,它把内存分割为很多不相关的区间(<code>Region</code>),每一个区间可以属于老年代或年轻代,并且每个区间上是可以物理上不连续的,老年代区间这个设计理念本身是为了服务于并行后台线程,这些线程的主要工作是寻找未被引用的对象,而这样就会产生一种现象,即某些区间的垃圾多余其它区间,(<code>垃圾回收时都是需要停下应用程序,不然没办法防止应用程序的干扰</code>),然后<code>G1</code>可以集中精力在垃圾最多的区间上,并且只需要一点点时间就可以清空这些区间垃圾,腾出完全空闲的时间.总而言之:<code>G1侧重点在于处理垃圾最多的区间,所以叫Garbege First</code><br />
*3 : G1内部主要有四个操作阶段:</p>
<blockquote><p>1:年轻代回收 (A young Collection)<br />
2: 运行在后台的并行循环(A background Concurrent Cycle)<br />
3: 混合回收(A mixed Collection)<br />
4: 全量回收 (A full GC)</p></blockquote>
<h3>2 进程和线程</h3>
<p>1: 子进程和父进程有<code>不同的代码和数据空间</code>,而<code>多个线程共享数据空间</code>,每个线程都有自己的<code>执行堆栈和程序计数器</code>为其执行上下文</p>
<h3>3 java 里面的4中引用类型</h3>
<blockquote><p>1: <strong>强引用</strong> 在一个线程内,无需直接引用直接可以使用的对象,除非引用不存在了,否则不会被GC清理了, <code>==</code>操作用于表示两个操作数所指向的堆地址空间地址是否相同,不表示两个操作数所指向的对象是否相等<br />
2: <strong>软用于</strong>,JVM抛出OOM之前,GC会清理所有的软引用对象,垃圾回收器在莫个时刻决定回收软可达的对象的时候,会清理软引用,并可选的把引用放到一个引用队列(<code>Reference Queue</code>),类似弱引用,只不过java虚拟机会尽量让软引用存活时间长一点,破不得一才清理.<br />
3<strong>弱引用</strong> (<code>Weak Rederence</code>) 弱引用和软引用的最大不同在于:当GC在进行回收时,需要通过算法检查是否回收软引用对象,而对于弱引用对象,GC总是进行回收.弱引用对象更容易,更快被GC回收.GC在运行时一定回收弱引用对象,但是关系复杂的弱引用对象群常常需要好几次GC的运行才能完成<br />
4<strong>虚引用</strong>(Phantom Reference): 主要目的是在一个对象所占用的内存被实际回收之前得到通知,从而进行一些相关清理工作,虚引用在创建时必须提供一个引用队列作为参数,其次虚引用对象的get方法总是返回null,因此无法通过虚引用来获得被引用的对象<br />
5:<strong>finalization机制</strong>: finalize方法和c++中的析构函数类似,但是<code>java采用的是基于垃圾回收器的自动内存管理机制</code>,所以finalize方法在本质上不同于c++的析构函数,当垃圾回收器发现没有引用指向一个对象时,会调用这个对象的finalize方法,通常这个方法会进行一些资源释放和清理的工作,比如关闭文件,套接字或数据库链接<br />
  由于finalize方法存在,虚拟机中的对象一般<code>处于三种可能的状态</code> (1)可达到状态(2)可复活状态(腹泻了finalize方法)(3)不可到达状态,垃圾回收器自由释放对象所占用内存<br /><code>finalize()只会被JVM自动调用一次,也就是只有一次拯救自己的机会</code></p></blockquote>
<h3>4并行</h3>
<p>在Hotpot垃圾搜集器里除了G1之外,其他的垃圾收集器使用的是内置的JVM 线程执行GC的多线程操作,而G1 GC 采用的是应用线程承担后台运行的GC工作,即当VM线程线程处理速度慢时,系统会调用应用线程帮助加速垃圾回收过程.<br />
并发在JVM里面是指垃圾收集线程和用户线程同时执行,但不一定是并行执行,可能是交叉执行,用户线程继续运行,而垃圾手机线程运行在另一块CPU上.</p>
<h3>5 分代</h3>
<p><strong>1:</strong> heap上的分代: Eden survivor spaces virtual1(称Young) --&gt; ... Virtual1(Tenured) --&gt; Perm(存放Class and Meta) (Young代MinorGC,每执行一次,对象年龄+1, (Tenured区叫Full GC) <code>注意</code>GC不会在主程序运行期对PernGen Space进行清理,如果应用程序会加载很多类的时候,就可能出现PermGen Space  错误,例如加入的第三方包太多导致<br /><strong>2: </strong> jdk7的更新过程中,永久区还是存在并使用的,只不多已经开始从他内部移除数据了,大致一共移除三类数据:<br />
(1) 例如&amp;APPLID这样的符号(Symbols)被移到了<code>本地堆区</code><br />
(2)内部字符串被移到了java堆区<br />
(3)类的静态属性被移到了Java堆区<br />
如果你使用jdk7而使用G1 GC ,那么永久区只有在Full GC阶段才会被回收,G1只会在永久区满了之后才会调用Full GC事件,或者在应用程序的生产速度比G1的垃圾回收速度块时调用<br /><code>JDK8 JVM 开始使用本地化的内存空间来存放元数据,这个空间叫做元空间(Meta Space)</code>这样修改就意味着OOM:PermGen的问题不存在了,并且不需要调整和监控这个空间,<code>JDK8完成了对永久区的移除</code></p>
<h3>6 Full Gc的条件(除了System.gc)</h3>
<blockquote><p>1: 老年代空间不足,当执行Full GC之后任然不足的会抛出如下 OOME:Java heap space<br />
2:永久代空间满,永久代中存放一些类的信息,当系统中要加载的类,反射的类和调用的方法较多时,永久代可能会占满,执行Full GC之后任然回收不了会抛出OOME:PermGen space<br />
3:CMS GC时出现Promotion Failed and Concurrent Mode Failure<br />
尤其要注意GC日志中有这两种情况很可能会出现Full GC,PromotionFailed是在进行MinorGC时,SurvivorSpace放不下了,对象只能放入老年代,而此时老年代也放不下造成的. Concurrent Mode Failure 是在执行CMS GC的过程中,同时有对象要放入老年代,而此时老年代空间不足造成的<br /><code>应对措施</code>:增大Survivor Space,老年代空间或调低并发GC的比率<br />
4:统计得到的MinorGC晋升到老年代的平均大小大于老年代的剩余空间</p>
<h3>7 java中GC Roots包括以下内容:</h3>
<p>1: 虚拟机栈中引用的对像<br />
2:方法区中类静态属性实体引用的对象<br />
3:方法区中常量引用对象<br />
4:本地方法栈内JNI引用的对象</p>
<h3>8 GC 参数</h3>
<p>1 G1之前: -XX:+UseSerialGC -Xloggc:gc.log -XX:+PrintGCDetails<br />
2: G1 : -XX:+UseSerialGC -Xlog:gc:gc.log -Xlog:gc*</p>
<h3>9 堆外内存(off-heap memory)</h3>
<p>JVM内部会把内存分为Java使用的堆内存和native使用的内存,他们之间是不能共享的,就是说当native内存用完了时,如果Java内存堆有空闲,这是native回向jvm申请而不是直接使用Java堆内存<br /><code>线程栈,应用程序代码,NIO缓存用的都是堆外内存</code>,事实上,c/c++中,使用的也是未托管内存,在Java中使用托管内存或者堆内存是这门语言的一个特性.<br />
使用<code>堆外内存</code>和<code>对象池</code>都能减少GC的暂停时间.<br /><strong>堆外内存</strong>的好处:<br />
1: 可以扩展更大的内存空间,比如超过1TB甚至比主内存还大的空间<br />
2: 理论上可以减少GC暂停时间<br />
3:可以在进程间共享,减少JVM间对象复制,使得JVM的分割部署更容易实现<br />
4:持久化存储可以支持快速重启,同时还能够在测试环境中重现生产数据<br /><strong>堆外内存</strong>的缺点:<br />
1:数据结构变得有些扭曲<br />
2:可能需要一个简单的数据结构以便于直接映射到堆外内存<br />
3:使用复杂的数据结构并序列化和反序列化到内存中<br />
4:序列化比使用对象的性能差很多<br />
与其他方案比较,比如<code>堆缓存</code>,<code>消息队列</code>,使用<code>堆外内存</code>更简单,高效. <code>堆外内存</code>可以支持操作系统的同步写入,不需要异步去执行,但<code>可能丢失数据</code>,堆外内存的好处是能够<code>缩短映射时间</code>,映射1TB的数据只需要10ms</p></blockquote>
<h3>10 不推荐使用finalize释放资源:</h3>
<blockquote><p>1:在 finalize()时可能导致对象复活<br />
2:finalize()函数执行是没有时间保证的,她完全由GC线程决定,极端情况下,若不发生GC,则finalize()函数不执行<br />
3:一个糟糕的finalize()会严重影响GC的性能<br /><code>函数finalize() 是由FinalizerThread线程处理的</code>,方法的对象都会在被正式回收前加入FinalizerThread的执行队列,该队列由链表实现...</p></blockquote>
<h3>11 G1涉及术语</h3>
<p><code>MetaSpace</code> jdk8 HotSpot JVM 使用本地内存来存储类元数据信息并称为元空间(java8移除了永久区的概念,转而使用元空间)<br />
默认情况下,大部分类元数据都在<code>本地内存中</code>分配,类元数据只受可用的本地内存限制,并动态调整,新参数(<code>MaxMetaspaceSize</code>用来限制元数据的空间大小)<br /><code>-XX:MetaspaceSize</code>   初始化元空间大小(默认12M(32位JVM) ,16M(64位JVM))<br /><code>-XX:MaxMetaspaceSize</code>  最大元空间大小(默认本地内存)<br /><code>-XX:MinMetaspaceFreeRatio</code> 扩大空间的最小比例,当GC过后,内存占用超过这一比例,就会扩大空间.<br /><code>-XX:MaxMetaspaceFreeRatio</code>: 缩小空间的最小比例,当GC后,内存占用低于这一比例,就会缩小空间.<br /><code>Reclaimable</code> G1 GC 为了能够回收,创建了一系列专门用于存放可回收对象的Region,这些Region都在一个链表队列里面.这个队列只包含存活率小于 <code>-XX:G1MixedGCLiveThresholdPercent</code>(默认85%)的Region, Region的值除以整个Java堆区,如果大于<code>-XX:G1HeapWastePercent</code>(默认5%)则启动回收机制<br /><code>RSet</code> 全称是 <code>RememberdSet</code> 简称是<code>RSet</code>: 指跟踪指向某个堆区(Region)内的对象引用,在标记存货对象时,G1使用RememberSet的概念,将每个分区外指向分区内的引用记录在该分区的RememberSet中,避免了对整个heap的扫描,使得各个分区更加独立.堆内存中每个分区都有一个RSet,Rset的作用是让堆区能并行独立的进行垃圾集合.Rset所占用的JVM内存小于总大小的5%<br /><code>CSet</code> Collection Set 简称CSet即收集集合,保存一次GC中将执行垃圾回收的区间(Region),GC时在CSet中的所有存活数据(Live Data) 都会被转移(复制/移动).集合中的堆区可以是Eden Survivor或Old Generation. CSet所占用的JVM内存小于总大小的1%.<br />
可以看出: CSet相当于一个大圈,里面包含了很多小圈(Rset).这些圈圈都是需要被回收的信息,这样可以把CSet比作垃圾场,Rset是垃圾场里面一个个绿色可回收垃圾桶.<br /><code>G1 Pause Time Target</code>: G1停顿目标时间,由于垃圾收集阶段可能是独占试的,就会<code>引起应用程序的停顿</code>,这个停顿时间就是你所设置的期望时间.G1使用一个停顿预测模型去匹配用户设定的目标停顿时间,并且基于这个目标停顿时间去选择需要回收的Region的数量<br /><code>Root Region Scan</code> 这个阶段从根区间的扫描开始,标记所有可达的存活对象.由于在并行标记的执行过程中移动数据会造成应用程序的暂停.所有根区间扫描这个阶段需要在下一次评估中断开始执行直到结束.<br /><code>PLAB (Promotion Local Allocation Buffers)</code> 它被用于年轻代回收.PLAB的`<code>作用是避免多线程竞争相同的数据</code>.处理方式是每个线程拥有独立的PLAB,用于针对幸存者和老年空间.当应用开启的线程较多时,最好使用 -XX:-ResizePLAB来关闭PLAB()的大小调整,以避免大量的线程通信导致的性能下降.<br /><code>TLAB (Thread Local Allocation Buffers)</code> 即线程本地分配缓存,是一个线程专用的内存分配区域. 总的来说<code>TLAB是为了加速对象分配而生的</code>,由于对象一般会分配在堆上,而堆是全局共享的.因此在同一时间,可能会有多个线程在堆上申请空间.JVM使用TLAB这种线程专属的区间来避免多线程冲突,提高对象分配效率,<code>TLAB本身占用了eden区的空间</code>,即JVM会为每一个Java线程分配一块TLAB空间.<code>对于G1来说,TLAB是Eden的一个Region</code>,被一个单一线程用于分配资源.主要用途是让一个线程通过栈操作方式独享内存空间,用于对象分配.这样比多个线程之间共享资源要快得多.</p>
<p><code>Lock-free Manner</code>: TLAB调用本地线程的无锁竞争分配方式.<br />
对于GC来说,堆内存的压缩和栈检索通常是引起性能问题的瓶颈爆发点,基于锁的机制扩展能力不好,所以采用CAS/MCAS同步方式可以确保不会被其他线程阻塞.<br /><code>Region</code> G1收集器将堆进行分区,划分一个个区域,每次收集的时候,只收集其中几个区域,以此来控制垃圾回收产生的停顿时间,这就是<code>Region</code><br />
从字面来说Region表示一个区域,每个区域里面的字母代表不同的分代内存空间类型,如:<code>[E] Eden [O] Old [S] survivor</code> ,空白的区域不属于任何一个分区,G1 可以在需要的时候任意指定这个区域属于Eden或是O区之类的<br />
G1通过将内存空间分成区域(Region)的方式避免内存碎片问题,每个Region是大小一致的,从逻辑层面来说,他们又是连续的虚拟内存块,G1的并行全局标记阶段会决定整个堆区的存活对象,在这个标记阶段完成之后,G1就知道哪些Region是空的了.<br /><code>Ergonomics Heuristic Decision</code> 字面意思是人体工程学,可以理解为适合人类理解的行为或习惯<br /><code>Evacuation Failure</code> 可以理解为提升失败(Promotion Failre) ,to-space exhaustion to-space overflow这个异常通常发生在提升对象时发现内存空间不足.<br /><code>Top-at-mark-start</code> 每个区域都记录这两个TAMS指针(top-at-mark-start),分别为 prevTAMS,nextTAMS,在TAMS以上的对象时新分配的,因而被视为隐式标记.</p>
<h3>12 Java虚拟机内存模型</h3>
<p><strong>1</strong> jvm将内存数据分为5个部分: <code>程序计数器 虚拟机栈 本地方法栈 Java堆 方法区</code>简单来说: 程序计数器用于存放下一条运行时指令,虚拟机栈和本地方法栈用于存放函数调用堆栈信息,Java堆用于存放Java运行时所需要的对象等,方法区用于存放程序的类元数据信息</p>
<p><code>线程共享区域(堆内存区,方法区,运行时常量池)</code><br /><code>-XSS设置虚拟机栈的大小</code>,栈里面存放栈帧(Stack Frame)<code>栈帧</code>里面存放:局部变量表,操作数栈,动态链接方法和返回地址等信息<br /><code>栈帧由3部组成:</code>:局部变量区(Local Variable) ,操作数栈(Operand Stack) ,帧数据区(Frame Data)</p>
<p><code>Escape Analysis(逃逸分析)</code>:指分析指针动态范围的方法,他与编译器优化原理的指针分析和外形分析相关联,通俗点:如果一个对象的指针被多个方法或线程引用时,那我们可以称这个指针发生了逃逸.一般出现在三种场景:<code>全局变量赋值</code> <code>方法返回值</code> <code>实例引用传递</code></p>
<pre><code>static class B{
        public void printClassName(G g){
            System.out.println(g.getClass().getName());
        }
    }
    static class G{
        public static B b;
        public void globalVarPointEscape(){
             b = new B();//给全局变量赋值,发生逃逸
        }
        public B methodPoint(){
            return new B();//方法返回值,发生逃逸
        }
        public void instancePassPointer(){
            methodPoint().printClassName(this);//实例引用发生逃逸
        }
    }
</code></pre>
<p><strong>java里面缺少像C#里面的值对象或者C++里面的struct,栈里面只保存了对象指针,当对象不再使用后需要依靠GC来遍历引用树并收回内存,如果对象较多,会影响性能</strong><br />
*Java7开始支持对象的栈分配和逃逸分析机制,此外,逃逸分析还有其他2个优化应用,<code>同步消除</code> <code>矢量代替</code> ,<code>同步消除</code>:逃逸分析可以判断出某个对象是否只被一个线程访问,如果只被一个线程访问.那么该对象的同步操作会转化为没有同步操作,提高性能, <code>矢量代替</code>:逃逸分析方法如果发现对象内存储结构不需要连续进行的话,就可以将对象的部分或者全部都保存在CPU寄存器内</p>
<p><strong>Java7完全支持栈式分配对象,JIT支持逃逸分析优化,还默认支持OpenGL的加速功能</strong><br /><code>方法区</code>:主要保存的信息是类的元数据,和堆空间类似,也是被JVM所有线程共享,包括</p>
<ul>
<li>类型信息(类的完整名称,父类完整名称,类型修饰符),</li>
<li>常量池,</li>
<li>方法信息,和</li>
<li>类型的直接接口类表`</li>
</ul>
<p><em>*</em>在HotSpot虚拟机中*<code>方法区也被称作是永久区,是一块独立于堆空间的内存空间</code> 永久区GC: (1)对永久区常量池的回收(2)类元数据的回收</p>
<p><strong>三种常见的垃圾回收算法: (Mark-Sweep) <code>标记清除</code> ,<code>复制算法</code>(Copying) <code>标记压缩</code>(Mark-Compact)</strong></p>
<p><code>mutator and colletor</code>:collector就是指的垃圾收集器,而mutator是指垃圾收集器之外的部分,例如我们的应用程序本身,mutator指责就是NEW(分配内存) READ(从内存中读取内容) WRITE(将内容写入内存) ,而colletor则是回收不再使用的内存来供mutator进行NEW操作,mutator根对象一般指的是分配在<code>堆内存</code>之外,可以直接被mutator直接访问到的对象,一般指<code>静态/全局变量以及ThreadLocal变量</code></p>
<ul>
<li>标记清除:  分为2个阶段: <code>标记和清除</code></li>
</ul>
<table>
<thead>
<tr>
<th>Mark-Sweep</th>
<th>Mark-Compact</th>
<th>Copying</th>
</tr>
</thead>
<tbody>
<tr>
<td>速度</td>
<td>中等</td>
<td>最慢</td>
</tr>
<tr>
<td>空间开销</td>
<td>少(但会积累碎片)</td>
<td>少(没有碎片)</td>
</tr>
<tr>
<td>移动对象</td>
<td>否</td>
<td>是</td>
</tr>
</tbody>
</table>
<blockquote><p>标记清除最大缺点: 存在大量的空间碎片.</p></blockquote>
<ul>
<li>复制算法: 复制效率高,但是内存缩小一半,一般采用分代: java heap 分为 YounGen and OldGen, 其中Young分为Eden s0 s1 ,其比例为8:1 ,</li>
<li>标记压缩: 一般用在老年代中,标记清除算法不仅效率底下而且执行完还有内存碎片,JVM对此进行了改进产生了标记压缩,先标记再压缩,老年代执行full gc</li>
<li>增量算法(Incremental Collecting): 思路简单,一个线程收集另一个线程执行应用程序,这样就不会stop-the-world, 但是有缺陷,一个线程辛辛苦苦标记的垃圾会被另一个线程影响.<code>增量算法的基本思想是</code>:如果一次性将所有的垃圾进行处理,需要造成系统长时间的停顿,那么就可以让垃圾收集线程和应用线程交替执行.缺陷就是线程切换和上下文转换消耗,会使得垃圾收集成本上升造成系统吞吐量下降.</li>
<li>分代收集算法:(Generational Collecting) : 基于对象生命周期分析后得出的垃圾回收算法.他把对象分为,年轻代,老年代和持久代,对不同生命周期的对象使用不同的算法进行回收. JVM(j2se 1.2)都是使用此算法.</li>
<li>评估GC的性能</li>
</ul>
<table>
<thead>
<tr>
<th>属性</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>吞吐量</td>
<td>程序的运行时间(程序运行时间+内存回收时间)</td>
</tr>
<tr>
<td>垃圾收集开销</td>
<td>吞吐量的补数,垃圾收集器所占时间与总时间比例</td>
</tr>
<tr>
<td>暂停时间</td>
<td>执行垃圾收集,程序的工作线程被暂停时间</td>
</tr>
<tr>
<td>收集频率</td>
<td>相对于应用程序的执行,收集操作发生的频率</td>
</tr>
<tr>
<td>堆空间</td>
<td>Java堆区所占的内存大小</td>
</tr>
<tr>
<td>快速</td>
<td>一个对象从诞生到被回收所经历的时间</td>
</tr>
</tbody>
</table>
<ul>
<li>垃圾收集器分类</p>
<ul>
<li>Serial/Serial Old</li>
<li>ParNew</li>
<li>Parallel Old</li>
<li>CMS (Concurrent-Mark-Sweep)</li>
<li>G1(garbage first)</li>
</ul>
</li>
<li>垃圾收集器的分类
<ul>
<li>[串行收集器]: (1)他仅仅用单线程进行垃圾回收(2)他是独占式的垃圾回收</li>
<li>[并行收集器]: (1) 也是独占式 (2)简单的将串行回收器多线程化,他的回收策略,算法,参数和串行回收器一样</li>
</ul>
</li>
<li>Serial 收集器:<br />
<blockquote><p>0: 串行回收和 stop-the-world<br />
1: -XX:+UseSerialGC 手动指定使用Serial收集器执行内存回收任务.<br />
2: 该算法步骤: (1)在老年代标记存活对象(2)从头开始检查堆内存空间,并且只留下依然幸存的对象(清除)(3)从头开始,顺序的填满堆内存空间,将存活的对象连续存放一起,这样堆分成2部分,一边有存放的对象,一遍没有对象(整理) (4) : Serial收集器应用于小的存储器和少量的CPU</p></blockquote>
</li>
<li>年轻代串行收集器
<ul>
<li>在HotSpot虚拟机中,使用<code>-XX:+UseSerialGC</code> 参数可以指定使用年轻代串行收集器和老年代串行收集器,当JVM在client模式下运行,它是<code>默认的垃圾收集器</code></li>
</ul>
</li>
<li>老年代串行收集器
<ul>
<li>老年代串行收集器使用的是标记压缩算法.和年轻代串行收集器一样,也是独占式串行收集器,但是老年代一旦启动垃圾收集,应用程序会停顿好几秒,<code>也可以使用 -XX:+UseParNewGC,指定年轻代使用并行收集器老年代使用串行收集器</code></li>
</ul>
</li>
<li>ParNew 收集器
<ul>
<li>ParNew 是Serial收集器的多线程版本.基本没有区别,<code>如果使用 -XX:+UseParallelGC 表示年轻代使用并行回收器,老年代使用串行收集器</code> ,ParallelGC和ParNew不同,Parallel可以控制程序吞吐量大小,因此他也称为吞吐量优先的垃圾收集器.可以使用<code>-XX:GCTimeRatio</code>设置执行内存回收的时间所占用JVM运行总时间比例,也就是控制GC执行频率.公式为1/(1+N).默认值为99/也就是只有1%的时间用于执行垃圾回收.</li>
</ul>
</li>
<li>CMS收集器(非独占式):
<ul>
<li>1:  一个优秀的老年代垃圾收集器. 低延迟是他的优势,算法采用<code>标记清除</code>,因此也会有 'Stop-The-World'机制而出现短暂暂停.</li>
<li>2: CMS执行的四个阶段: 初试标记(Init-Mark) 并发标记(Concurrent-Mark) 再次标记(Remark) 和并发清除(Concurrent-Sweep)</li>
<li>3: 尽管CMS收集器采用的是并行回收,但是初始化和再标记阶段任然要STW机制暂停工作线程,不过时间不长.</li>
<li>4: 前面的几个老年代收集器  Serial Old and Parallel Old收集器都采用算法都是标记清除,因此没有full<br />
gc之后的内存碎片,而CMS采用的是标记清除,意味着每次执行完会有内存碎片.那么CMS在为新对象分配内存之后,将无法使用<code>指针碰撞(Bump the pointer)</code>技术.而只能选择<code>空闲列表(Free List)</code> 执行内存分配.</li>
</ul>
</li>
<li>G1 收集器
<ul>
<li>1: G1 GC 切分堆内存为多个区间(region),从而避免了很多GC操作在整个Java堆或者整个年代进行.</li>
<li>2: 在JVM启动的时候不需要立即指定哪些Region属于年轻代,哪些Region属于老年代,因为他们都不需要一大块连续的内存.</li>
<li>3: G1的年轻代收集阶段是一个并行的独占式收集器.当一个年轻代进行收集时,整个年代都会被收回,所有的应用线程会被中断,G1 GC会启用多线程执行年轻代回收, 和年轻代不同,老年代G1回收器和其他Hotspot不同,<code>G1的老年代回收器不需要整个老年代被收回,一次只需要扫描/收回一小部分老年代Region就行了,需要注意的是,这个老年代Region是和年轻代一起被收回的</code></li>
<li>4: G1 把整个Java堆划分为若干个区间(Region),每个region大小为2的倍数.范围在1M-32M之间.所有的region有一样的大小,在JVM生命周期内不会被改变. <code>CSet包含一系列的Region,每一个Region有一个Rset,这个Rset包含了相应Region里面所有指针的位置集合.Rset大小和Region数量有直接关系.一般来说RSet的大小占整个Java堆空间的1%-20%</code></li>
<li>5: <code>可用Region</code>:就是unused Region,Eden Region SurvivorRegion 组成了年轻代空间.</li>
<li>6: G1对于大对象有特殊的分配方式,一个大对象是指该对象的大小超过一个Region大小的50%以上,这个大小包含了Java对象头.</li>
</ul>
</li>
<li>全垃圾收集(Full Garbage collection)
<ul>
<li>1: G1 的FULL GC和Serial GC的Full GC 采用的是同一种算法.Full GC 会对整个Java堆进行压缩,G1的Full GC 是单线程的,会引起较长时间的停顿.因此G1的设计目标就是减少FUll GC的发生次数.</li>
<li>2:  <code>并行循环</code>(Concurrent Cycle) ,一个G1的并行循环包括几个阶段的活动: <code>初试标记(initialmarking)</code> <code>并行Root区间扫描和清除(Cleanup)</code>,除了最后的cleanup阶段以外,其余阶段都属于标记存活对象阶段.</li>
</ul>
</li>
<li>3: 初始标记阶段的目的是收集所有的GC 根(Roots).<code>Roots是一个对象的起源指针</code>. 为了收集根应用,从应用线程开始,应用线程必须停下,所以他是一个独占式.<code>由于一个年轻代GC必须收集所有的Roots,所以G1的初始标记在一个年轻代GC里完成</code>
<ul>
<li>4: 并行根区间扫描阶段必须扫描和标记所有的幸存者区间的对象引用,这一阶段可以并行执行.</li>
<li>5: 重标记阶段是一个独占式阶段,通常是一个很短的暂停.这个阶段会完成所以的标记工作.</li>
<li>6: 清除阶段:没有包含存活对象的Region会被回收.并随即被加入Region队列.这个阶段的重要意义是最终决定了哪些Region可以进入混合GC ,在G1内部,混合GC是非常重要的释放内存机制,避免了G1出现没有可用的Region的情况发生.否则就会出现Full GC的情况.</li>
</ul>
</li>
<li>堆大小(Heap Sizing)
<ul>
<li>G1的Java堆通常由多个Region组成,设置堆大小的选项和其它的GC一样,都是由 <code>-xms</code> 和 <code>-xmx</code>的配置</li>
<li>以下情况可能会<code>增大堆内存</code>大小<br />
(1):Full Gc 阶段<br />
(2): Young或者Mixed GC发生时,G1 计算GC算费时间与Java线程的花费时间比例,如果<code>-XX:GCTimeRatio</code> 设置GC花费时间很长,则堆大小会增大.这样就会使G1发生GC的频率降低. 这个值默认是9 所有其它HotSpot GC的默认值是99<br />
(3): 如果一个对象分配失败,即便一个GC刚刚结束,G1采取的策略不是立即重复Full GC,而是通过增大堆内存大小,确保对象分配成功<br />
(4): 当GC申请加入一个新的Region时.</li>
</ul>
</li>
<li>Java永久区:
<ul>
<li>1: 类中包含的元数据: 类的层级信息,方法数据和方法信息(字节码,栈,和变量大小),运行时常量,已确定的符号引用和虚方法表.</li>
<li>2: 在Java8之前这些数据都放在 <code>永久区</code>,永久区的垃圾回收和老年代的垃圾回收是绑定的,一旦一个区被占满就进行垃圾回收.</li>
<li>3: Java8之后,没有永久区,这些数据<code>被移到了一个与堆不像连的本地内存区域</code> ,也就是元空间.这就不会出现<code>永久区内存溢出或者出现泄漏的数据移到交换区这样的事情</code></li>
<li>4: 元空间的内存管理由<code>元空间虚拟机</code>来完成,之前,对于类的元数据需要不同的垃圾回收器进行处理,`<code>现在只需要执行元空间虚拟机的C++代码即可完成</code>.在元空间中,类和元数据的生命周期和其对应的类加载器是相同的. 换句话说: <code>只要类加载器存活,其加载的类的元数据也是存活的,因而不会被回收掉</code></li>
<li>5: <code>每一个类加载器的存储区域都称作一个元空间.所有的元空间和在一起就是我们一直说的元空间</code>,当一个类加载器被垃圾回收标记为不再存活时,其对应空间会被回收,在元空间回收过程中没有重定位和压缩等操作.但是元空间内的元素会进行扫描来确定Java应用.<br />
-6: 元空间虚拟机复制元空间的分配,其采用的形式为组块分配.组块的大小因类加载器的类型而异.在元空间虚拟机中存在一个全局的空闲组块列表.当一个类加载器需要组块时,他就会从这个全局的组块列表中获取并维持一个自己的组块列表,当一个类加载器不再存活时,其持有的组块将会被释放.并返回给全局列表.类加载器持有的组块又会被分成多个块,每一个块存储一个单元的元信息.组块中的块是线性分配的(指针碰撞分配形式),组块分配自内存映射区域.这些全局的虚拟内存映射区域以链表形式链接.一旦某个虚拟内存映射区域清空,这部分内存就会 操作系统.</li>
<li>7: <code>元空间虚拟机控制元空间的增长</code>, 可以用: <code>-XX:MaxMetaspaceSize</code>来设定,默认没有限制.因此元空间可以延伸到交换区,但是这时候进行本地内存分配会失败.</li>
<li>8: 元空间虚拟机采用了组块分配的形式,同时区块的大小由类加载器类型决定.类信息并不是固定大小的,因此可能分配的空闲区块和类需要的区块大小不同.这种情况可能导致碎片存在.<code>元空间虚拟机目前不支持压缩操作,所以碎片化是目前最大的问题</code></li>
</ul>
</li>
</ul>
<h3>13 GC 的参数调试</h3>
<ul>
<li>输出样式</li>
</ul>
<table>
<thead>
<tr>
<th></th>
<th>输出</th>
<th>参数</th>
<th>使用场景</th>
<th>是否独占</th>
</tr>
</thead>
<tbody>
<tr>
<td>串行收集器</td>
<td>输出DefNew</td>
<td>-XX:+UseSerialGC()</td>
<td>年轻代老年代都使用</td>
<td>是</td>
</tr>
<tr>
<td>并行收集器</td>
<td>输出ParNew</td>
<td>-XX:+UseParNewGC()</td>
<td>年轻代(并行)老年代(串行)</td>
<td>部分</td>
</tr>
<tr>
<td></td>
<td>PSYoungGen</td>
<td>-XX:+UseParallelOldGC()</td>
<td>年轻代老年代都使用并行</td>
<td>部分</td>
</tr>
<tr>
<td></td>
<td>PSYoungGen</td>
<td>-XX:+UseParallelGC()</td>
<td>年轻代(并行)老年代使用CMS</td>
<td>部分</td>
</tr>
<tr>
<td></td>
<td>GarbageFirst heap</td>
<td>-XX:+UseG1GC()</td>
<td>特殊收集器</td>
<td>部分</td>
</tr>
<tr>
<td>一般来说,</td>
<td>只有在嵌入式产品下</td>
<td>才使用SerialGC</td>
<td>-</td>
<td>-</td>
</tr>
</tbody>
</table>
<ul>
<li><code>使用java -X</code>可以输入参数意思</li>
<li><code>-Xloggc</code>  --&gt; <code>-XX:+PrintGCDetails -verbose:gc -Xloggc:gclog</code></li>
<li><code>-XX:+UseSerialGC -verbose -Xlog:gc:gc.log -Xlog:gc*</code></li>
<li><code>-Xlog:gc:gc.log -Xlog:gc* -XX:+PrintFlagsFinal -XX:+UnlockDiagnosticVMOptions</code>: 在GC里面有一些选项称之为诊断选项(Diagnostic Options), 可以通过这俩个选项组合起来运行.就可以输出并查看这些选项.</li>
</ul>
<h3>15 深入理解G1 GC</h3>
<ul>
<li>G1 GC采用递增,并行运算,独占式的特征方式,并采用<code>拷贝技术</code>实现自身的压缩目标,同时通过并行的多级标记的方式缩短各层级(标记,重标记,清除等阶段)的停顿时间.</li>
<li>在G1中 堆被分成若干个大小相等的Region,每个Region都有一个相关联的RememberSet简称RSet,RS里面的数据结构是Hash表,里面的数据时Card Table(堆中每512个Byte映射在card table 1 byte).简单地说,<code>RS里面存在的都是Region中存活对象的指针</code>,当region中数据发生变化时,首先反映到Card Table中的一个或多个Card上.RS通过扫描内部Card Table得知Region中内存使用和活动对象.在使用R给哦你的过程中,如果Region被填满了.分配内存的线程会重新选择一个新的Region.空闲Region被组织到一个基于链表的数据结构(LinkedList)里面,这样可以快速找到新的Region.
<ul>
<li>G1 的收集过程涵盖4个阶段: <code>年轻代GC</code> <code>并发标记周期</code> <code>混合收集</code> <code>Full GC</code></li>
<li>堆区间大小也决定了什么对象可以认定为<code>大对象</code>,大对象通常是很大的对象,占据了超过G1 GC区间的50%,<code>大对象没有按照年轻代的回收方式把对象放入老年区,而是放置在老年区以外的大对象区间里面,即单独分离出来形成一片新的区域,独立管理,</code></li>
<li><code>大对象在堆内存里是物理连续的</code>,所以在回收阶段尝试去频繁的回收大对象,存在2个缺点: (1)移动对象需要 拷贝数据,大对象较大,拷贝效率会成为瓶颈.(2)很难找到连续的堆内存用于大对象存储,回收越频繁,越容易出现互相独立的区间.</li>
<li>大对象并没有包含在年轻代或老年代存储空间里,所以不能采用年轻代针对<code>TLAB</code> 和 <code>PLAB</code>的分配或者优化措施.</li>
<li><code>任何一次垃圾回收都会释放CSet里面所有空间.一个CSet由一系列的等待回收区间所组成</code></li>
<li><code>RSet是一个数据结构,这个数据结构帮助维护和跟踪在他们单元内部的对象引用信息,在G1里这个单元就是Region,G1里面的每一个RSet对应的是一个区间内部的对象引用情况,有了RSet就不需要扫描整个堆内存了,当G1 执行STW独占式回收(年轻代,混合回收)时,只需要扫描每一个区间内部的RSet就可以了.因为所有RSet都保存在CSet里面,即: *Region-RSet-CSet*这样的概念.所有一旦区间内部存活对象被移除,RSet里面保存的引用信息也会被立即更新.这样我们就可以认为RSet就是一张虚拟的对象引用表了...每个区间内部都有这么一张表存在,帮助对区间的内部的对象存活情况,基本信息做有序高效的管理</code></li>
<li>Region并不是最小的单元,每个区间会被进一步划分为若干个块(Chunks),在G1区间里,<code>最小单元是512字节的堆内存块(Card)</code> ,G1为每个区间设置一个全局内存表快来帮助维护所有的堆内存块.</li>
<li><code>RSet帮助维护和跟踪指向G1区间的引用,而这些区间本身拥有这些RSet, 并行Refienment线程的任务是扫描更新日志缓存,并且更新区间RSet,为了更加有效的支援这些Refinement线程的工作.在并行回收阶段,所有未被处理的缓存(已经有日志写在里面了)都会被工作线程拿来处理.这些缓存也被称为日志里面的处理缓存</code></li>
</ul>
</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 21:38:34</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Garbage First的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MWdmXp.html" rel="bookmark">浅谈PHP5中垃圾回收算法（Garbage Collection）的演化</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言:PHP是一门托管型语言,在PHP编程中程序员不需要手工处理内存资源的分配与释放(使用C编写PHP或Zend扩展除外),这就意味着PHP本身实现了垃圾回收机制(Garbage Collection).现在如果去PHP官方网站(php.net)可以看到,目前PHP5的两个分支版本PHP5.2和PHP5.3是分别更新的,这是因为许多项目仍然使用5.2版本的PHP,而5.3版本对5.2并不是完全兼容.PHP5.3在PHP5.2的基础上做了诸多改进,其中垃圾回收算法就属于一个比较大的改变.本文将分别			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrag6b.html" rel="bookmark">Garbage Collection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3)Garbage Collection State the behavior that is guaranteed by the garbage collection system and write code that explicitly makes objects eligible for collection. 1.    Garbage collection is a mechanism for reclaiming memory from objects that are no l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyYR8M.html" rel="bookmark">漫谈&period;Net中的自动垃圾收集&lpar;Garbage Collection&rpar;机制&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:cornfield漫谈.Net中的自动垃圾收集(Garbage Collection)机制    一直以来,垃圾收集(Garbage Collection)在软件界的名声并不好.很多程序员认为垃圾收集做得不如自己来的直接,高效.这种说法有些时候是对的,一个精心为自己的特定程序设计定制的内存回收方法,肯定比为所有程序提供垃圾回收性能要高.但那对程序员要求甚高,一个项目下来花在内存回收的设计上的时间和精力是很可观的,而稍有不慎便会酿成灾难性的错误,技术再高超的程序员负担不起,整个现代软件工业也			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmNx6b.html" rel="bookmark">细述 Java垃圾回收机制&srarr;How Java Garbage Collection Works&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这是垃圾回收机制系列文章的第二篇.希望您已经读过了第一部分Java垃圾回收简介. Java垃圾回收是一个自动运行的管理程序运行时使用的内存的进程.通过GC的自动执行JVM将程序员从申请和释放内存的繁重操作中解放出来. Java垃圾回收GC初始化 作为一个自动执行的进程,程序员不需要在代码中主动初始化GC.Java提供了System.gc()和Runtime.gc()这两个hook来请求JVM调用GC进程. 尽管要求系统机制给程序员提供调用GC的机会,但是实际上这是由JVM负责决定的.JVM可以选			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeRejNb.html" rel="bookmark">细述 Java垃圾回收机制&srarr;Types of Java Garbage Collectors</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文将会介绍各种不同类型的Java垃圾回收器.垃圾回收是Java用来将程序员从分配和释放内存的琐事中解放出来的自动过程. Java有四种类型的垃圾回收器, Serial Garbage Collector Parallel Garbage Collector CMS Garbage Collector G1 Garbage Collector 这四种类型的垃圾回收器都有各自的优点和缺点.最重要的是程序员可以选择JVM使用哪种类型的垃圾回收器.我们可以通过传递不同的JVM参数来设置使用哪一个.各个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVd09QM.html" rel="bookmark">Mark-and-Sweep Garbage Collection</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				This section presents the mark-and-sweep   garbage collection algorithm. The mark-and-sweep algorithm was the first garbage collection algorithm to be developed that is able to reclaim cyclic data structures. Variations of the mark-and-sweep algorith			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boqa76p.html" rel="bookmark">细述 Java垃圾回收机制&srarr;Java Garbage Collection Monitoring and Analysis</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java垃圾回收监控和分析工具 Java VisualVM Naarad GCViewer IBM Pattern Modeling and Analysis Tool for Java Garbage Collector HPjmeter IBM Monitoring and Diagnostic Tools for Java – Garbage Collection and Memory Visualizer Verbose GC Analyzer Java VisualVM Java Vi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdLwG6p.html" rel="bookmark">Boehm-Demers-Weiser Conservative Garbage Collector 7&period;2发布 垃圾收集器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				The Boehm-Demers-Weiser conservative garbage collector 是一款C++ and C++ 的垃圾收集器.它可以使用C语言作为中间代码来实现多种编程语言,能够被用来作为一个C或C++程序的检漏仪.一个旧版本的垃圾收集器也包含GNU编译器(GCC)分布. Boehm-Demers-Weiser Conservative Garbage Collector 7.2该版本增加了许多改进和修正. 软件信息:http://www.hpl.hp.com/per			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5AdZmp.html" rel="bookmark">CLR探索系列-Server and Workstation Garbage Collection探索&lpar;垃圾回收系列&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CLR中的GC,存在着两种Mode.Server Mode的GC和Workstation Mode的GC.同时,在有些情况下,还会遇到并发的GC. Server GC只适合于在多CPU的主机上面使用.这种GC模式,为每一个处理器都独立的创建一个GC Heap,这样就可以进行并发的同步的收集.这样做的好处也是显而易见的:在相同的时间里面可以处理更多的用户请求.切实的带来性能的成倍提升.同时,这中模式相对于在多处理器下使用并发模式更加的有效. 而Workstation Mode GC,它适合于单处理			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnKxZz.html" rel="bookmark" class="title">ie9无法安装怎么解决？</a>
					<div>
						电脑常识 1.首先查看用户下载的ie9版本是否我下载完成,有缺少文件的情况.建议网友去重新安装微软官方网站上的ie9,或者用的是老版本来升级到ie9,一般直接升级到ie9 的话是很少出现无法安装的情形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0zGd0Eb.html" rel="bookmark" class="title">百度再出新声明 内容始终是王道</a>
					<div>
						5.16日百度官方再出新声明,百度将实行长期持久战,对采集伪原创垃圾内容进行识别打击.这次的声明公告再次证明:内容是王道,长期坚持原创内容的网站,即将迎来新时代. SEO优化中一直提到原创高质量内容为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLeW8z.html" rel="bookmark" class="title">Photoshop绘制粉色水晶心形壁纸</a>
					<div>
						本教程的重点在单个的水晶心形的制作.看似简单的心形,如果要做出水晶立体的效果,还是要花费一点时间的. 本教程的重点在单个的水晶心形的制作.看似简单的心形,如果要做出水晶立体的效果,还是要花费一点时间的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNGR7p.html" rel="bookmark" class="title">ASP&period;NET热点问题解答14个</a>
					<div>
						asp.net|解答|问题 1.ASP.NET能在那些系统中运行?  目前,ASP.NET还只能奔跑在微软的Windows 2000.Windows XP和Windows 2003的系统中,并且需要微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7rO3b.html" rel="bookmark" class="title">Word文档中快速输入特定内容的方法</a>
					<div>
						  Word文档中快速输入特定内容的方法           1.单击&quot;文件&quot;按钮,在打开的面板中选择&quot;选项&quot;. 2.此时会打开名为&quot;Word选项&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjWKkp.html" rel="bookmark" class="title">ASP&period;NET 窗体间传值的方法</a>
					<div>
						这篇文章介绍了ASP.NET 窗体间传值的方法,有需要的朋友可以参考一下,希望对你有所帮助   假设ParentForm.aspx 页面上有TextBox1文本框和Open按钮 点击Open按钮弹出S ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDADl0b.html" rel="bookmark" class="title">SQL Server优化方法有哪些</a>
					<div>
						虽然查询速度慢的原因很多,但是如果通过一定的优化,也可以使查询问题得到一定程度的解决 查询速度慢的原因很多,常见如下几种: 1.没有索引或者没有用到索引(这是查询慢最常见的问题,是程序设计的缺陷) 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0PGkjM.html" rel="bookmark" class="title">jscript读写二进制文件的方法</a>
					<div>
						  jscript读写二进制文件的方法          这篇文章主要介绍了jscript读写二进制文件的方法,涉及javascript中ActiveXObject对象的使用技巧,具有一定参考借鉴价值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGZqyp.html" rel="bookmark" class="title">PS中创建一个精致的音频播放器界面</a>
					<div>
						  在PremiumPixels上看到N多可供下载的网页设计PSD文件,都非常精美.但它只提供了现成的文件,并没有提供教程,那么我就通过源文件自己摸索,向Orman Clark学习一下如何做出如此漂亮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYvV0b.html" rel="bookmark" class="title">win7电脑兼容性选项卡不见了怎么办</a>
					<div>
						  1.鼠标点击win7系统&quot;开始&quot;菜单,选择&quot;运行&quot;对话框;   电脑兼容性选项卡消失不见 2.在打开的&quot;运行&quot;对话框中输入gpedit. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ0Y6z.html" rel="bookmark" class="title">用PHP和MySQL保存和输出图片&lowbar;php基础</a>
					<div>
						设置数据库 我们通常在数据库中所使用的文本或整数类型的字段和需要用来保存图片的字段的不同之处就在于两者所需要保存的数据量不同.MySQL数据库使用专门的字段来保存大容量的数据,数据类型为BLOB. M ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRq5Oeb.html" rel="bookmark" class="title">急，求助高手。关于ASP&period;NET&period;在建立与服务器的连接时出错。在连接到 SQL Server 2005 时，在默认的设置下 SQL Server 不允许进行远程连接可能会导致此失败。</a>
					<div>
						问题描述 说明:执行当前Web请求期间,出现未处理的异常.请检查堆栈跟踪信息,以了解有关该错误以及代码中导致错误的出处的详细信息.异常详细信息:System.Data.SqlClient.SqlExc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6Qm7z.html" rel="bookmark" class="title">《精通VMware vSphere 6》&mdash;&mdash;第2章　规划与安装 VMware ESXi   2&period;1规划VMware vSphere部署</a>
					<div>
						第2章 规划与安装 VMware ESXi 第1章已经详细介绍了VMware vSphere套件及其应用程序,我们由此了解到VMware ESXi是vSphere的基础.虽然安装十分简单,但要成功部署 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmmOvM.html" rel="bookmark" class="title">接口的作用 面向对象设计</a>
					<div>
						问题描述 接口的作用 面向对象设计 不好意思,也许我这个问题很低级,但是困恼自己好久,今天鼓起勇气问下大家,希望各位oo大神能不吝赐教 如题,有一个和接口非常相似的存在:抽象类,它们都是对职责的抽象, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7vdZM.html" rel="bookmark" class="title">c＃访问oracle数据库</a>
					<div>
						问题描述 在创建oracle数据源时候弹出遇到不支持的数据类型,userdefined 解决方案 解决方案二:数据库有userdefined这个类型吗?貌似只是JavaScript里面有解决方案三:J ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKJgop.html" rel="bookmark" class="title">创业18般武器之如何办理网络文化经营许可证</a>
					<div>
						据中国音数协游戏工委.伽马数据(CNG中新游戏研究)发布的&lt;2016年7至9月移动游戏产业报告&gt;显示,TOP100游戏中52%为IP(原意指知识产权,现泛指为老百姓耳熟能详的.具有持久开发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjYeZM.html" rel="bookmark" class="title">阿里昨晚宣布B2B私有化每股注销价格13&period;5港元</a>
					<div>
						2月9日停牌的港股阿里巴巴(微博)昨天有重大新闻. 昨晚约7点半过后,阿里巴巴集团和阿里巴巴网络有限公司(1688.HK)联合宣布,阿里巴巴集团(&quot;要约人&quot;)向阿里巴巴网络有限公司 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLdELM.html" rel="bookmark" class="title">英特尔投资宣布任命许盛渊为中国区董事总经理</a>
					<div>
						英特尔公司全球投资机构--英特尔投资(Intel Capital)10日宣布许盛渊将担任其中国区董事总经理. 许盛渊此前担任英特尔投资中国区投资总监,他将常驻北京,管理英特尔投资在中国大陆和香港地区的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkaGvM.html" rel="bookmark" class="title">stringwriter  flush-StringWriter 调用flush后为什么缓存区还有内容？？</a>
					<div>
						问题描述 StringWriter 调用flush后为什么缓存区还有内容?? 如题: StringWriter sw=new StringWriter(); sw.write(&quot;aa&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBg8JdM.html" rel="bookmark" class="title">activity fragment-Android&mdash;&mdash;Activity和Fragment 的相关问题</a>
					<div>
						问题描述 Android--Activity和Fragment 的相关问题 错误内容 java.lang.RuntimeException: Unable to start activity Comp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0KvNp.html" rel="bookmark" class="title">C语言实现字母大小写转换的方法&lowbar;C 语言</a>
					<div>
						本文实例讲述了C语言实现字母大小写转换的方法.分享给大家供大家参考.具体实现方法如下: /* * 将大写字母转换为小写字母 */ #include &lt;stdio.h&gt; int lower( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmLmmz.html" rel="bookmark" class="title">12款经典的白富美型&mdash;jquery图片轮播插件&mdash;前端开发必备&lowbar;jquery</a>
					<div>
						图片轮播是网站中的常用功能,用于在有限的网页空间内展示一组产品图片或者照片,同时还有非常吸引人的动画效果.本文向大家推荐12款实用的 jQuery 图片轮播效果插件,帮助你在你的项目中加入一些效果精美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr0Aop.html" rel="bookmark" class="title">Tomcat服务器配置https双向认证（使用keytool生成证书）</a>
					<div>
						一,HTTPS原理 1,HTTP.HTTPS.SSL.TLS介绍与相互关系 (1)HTTP:平时浏览网页时候使用的一种协议.HTTP协议传输的数据都是未加密的(明文),因此使用HTTP协议传输隐私信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44A6rz.html" rel="bookmark" class="title">Java 多线程synchronized关键字详解&lpar;六&rpar;&lowbar;java</a>
					<div>
						synchronized 关键字,代表这个方法加锁,相当于不管哪一个线程(例如线程A),运行到这个方法时,都要检查有没有其它线程B(或者C. D等)正在用这个方法(或者该类的其他同步方法),有的话要等 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZmXAz.html" rel="bookmark" class="title">Java Thread Programming 1&period;7 - Concurrent Access to</a>
					<div>
						When multiple threads are interacting with an object, controls need to be in place to ensure that th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boL8WdM.html" rel="bookmark" class="title">Visual Studio中js调试的方法图解&lowbar;javascript技巧</a>
					<div>
						第一步:在需要打断点处写上 debugger; 第二部:在IE中将禁用脚本调试的钩去掉 打开IE -&gt; 工具 -&gt; 选项 -&gt; 高级 -&gt; 去掉禁用脚本调试(Internet  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1XLQb.html" rel="bookmark" class="title">SQLServer中SELECT语句的执行顺序&lowbar;MsSql</a>
					<div>
						今天在写一条语句的时候,在查询分析器里边执行 要用10s,换用另外一种写法只用少于1s的时间,同事说是因为Sql句语执行顺序的原因.之前看过一点相 关的书,有一点印象,到网上找了资料,学习下. 逻辑查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqADAp.html" rel="bookmark" class="title">如何在群里对某个人禁言&quest;</a>
					<div>
						问题描述 如何在群里对某个人禁言? 解决方案 有屏蔽群成员功能,不能对某个人禁言					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmekDp.html" rel="bookmark" class="title">eclipse导入html、js、xml报错的问题</a>
					<div>
						今天重新安装eclipse,在导入部分html.js.xml文件,报错,解决办法如下: eclipse-&gt;window-&gt;preferences-&gt;Team,点击validation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Q51Ap.html" rel="bookmark" class="title">java-webservice实现main方法的时候报错的，不知道在那里出错了，实在找不到原因</a>
					<div>
						问题描述 webservice实现main方法的时候报错的,不知道在那里出错了,实在找不到原因 Exception in thread &quot;main&quot; javax.xml.ws.We ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.035 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
